module Interfactura
  module Parser
    class FacturaInterfacturaEmisor
      include HappyMapper

      tag "if:Emisor"
      attribute "ri", String, tag: "RI"
    end

    class FacturaInterfacturaReceptor
      include HappyMapper

      tag "if:Receptor"
      attribute "ri", String, tag: "RI"
      attribute "activo", String, tag: "Activo"
    end

    class FacturaInterfacturaEncabezado
      include HappyMapper

      tag "if:Encabezado"
      attribute "id_interno", String, tag: "IdInterno"
      attribute "template_id", String, tag: "TemplateId"
      attribute "folio", String, tag: "Folio"
      attribute "folio_serie", String, tag: "FolioSerie"
      attribute "serie_folio", String, tag: "SerieFolio"
      attribute "serie", String, tag: "Serie"
      attribute "uuid", String, tag: "UUID"
      attribute "sub_total", String, tag: "SubTotal"
      attribute "iva", String, tag: "Iva"
      attribute "total", String, tag: "Total"
      attribute "observaciones", String, tag: "Observaciones"
      attribute "ivapct", String, tag: "IVAPCT"
      attribute "moneda", String, tag: "Moneda"
      attribute "lugar_expedicion", String, tag: "LugarExpedicion"
      attribute "tipo_cambio", String, tag: "TipoCambio"
      attribute "tipo_documento", String, tag: "tipo_documento"
      attribute "metodo_de_pago", String, tag: "metodoDePago"
      attribute "tipo_documento", String, tag: "totalImpuestosTrasladados"
      attribute "forma_de_pago", String, tag: "formaDePago"
      attribute "folio_referencia", String, tag: "FolioReferencia"
      attribute "regimen_fiscal_emisor", String, tag: "RegimenFiscalEmisor"
      attribute "email_tracking", String, tag: "EmailTracking"
      attribute "fecha", String, tag: "Fecha"
      attribute "cadena_original", String, tag: "cadenaOriginal"
      attribute "cadena_original_timbre", String, tag: "cadenaOriginalTimbre"
      attribute "cadena_original_emisor", String, tag: "cadenaOriginalEmisor"
      attribute "import_con_letra", String, tag: "importeConLetra"
    end

    class FacturaInterfacturaCuerpo
      include HappyMapper

      tag "if:Cuerpo"
      attribute "renglon", String, tag: "Renglon"
      attribute "cantidad", String, tag: "Cantidad"
      attribute "concepto", String, tag: "Concepto"
      attribute "p_unitario", String, tag: "PUnitario"
      attribute "importe", String, tag: "Importe"
      attribute "um", String, tag: "UM"
    end

    class FacturaInterfactura
      include HappyMapper

      tag "if:FacturaInterfactura"
      attribute "tido_documento_id", String, tag: "TipoDocumentoId"
      attribute "tipo_documento", String, tag: "TipoDocumento"
      attribute "id", String, tag: "Id"

      element "emisor", FacturaInterfacturaEmisor, tag: "if:Emisor"
      element "receptor", FacturaInterfacturaReceptor, tag: "if:Receptor"
      element "encabezado", FacturaInterfacturaEncabezado, tag: "if:Encabezado"
      element "cuerpo", FacturaInterfacturaCuerpo, tag: "if:Cuerpo"
    end
  end
end
