require 'interfactura/parser/comprobante'

module Interfactura
  module Parser
    class Resultado
      include HappyMapper

      tag 'Resultado'
      attribute "estado", String, tag: "Estado"
      attribute "detalle", String, tag: "Detalle"

      attribute "description", String, tag: "Descripcion"

      element "comprobante", Interfactura::Parser::Comprobante, tag: "cfdi:Comprobante"
      element "pdf", String, tag: "PDF"

      def success?
        estado == "OK" && detalle == "OK"
      end
    end
  end
end
