module Interfactura
  module Ruby
    class Invoice
      attr_accessor :total, :rfc, :name, :phone, :email,
                  :city, :municipality, :street, :number,
                  :zipcode, :state, :id, :colony, :order_id

      IVA = 0.16

      def initialize(attributes = {})
        @id = attributes[:id]
        @total = attributes[:total]
        @zipcode = attributes[:zipcode]
        @state = attributes[:state]
        @colony = attributes[:colony]
        @rfc = attributes[:rfc]
        @name = attributes[:name]
        @phone = attributes[:phone]
        @email = attributes[:email]
        @city = attributes[:city]
        @municipality = attributes[:municipality]
        @street = attributes[:street]
        @number = attributes[:number]
        @order_id = attributes[:order_id]
      end

      def subtotal
        (total / 1.16).round(2)
      end

      def iva
        (total - subtotal).round(2)
      end

      def to_xml
        path = "#{File.dirname(__FILE__)}/templates/message_template.xml.erb"
        ERB.new(File.read(path), nil, '-').result(self.get_binding)
      end

      def get_binding
        binding()
      end
    end
  end
end
